#CONTROLCODES 1
#INCLUDE "STANDARD.DEF"

HSCALE = $9F2A
VSCALE = $9F2B

## FIFOFULL = %10000000
## BIT16.ON = %00100000
## STEREO.ON = %00010000
## VOLMASK = %11110000
## VOLMAX = %11111111
## DefaultVolume = 14
## MaxVolume = 15

VERABASERATE = 48828.15
VERARATEDIVISOR = 128

  PRINT "{ISO ON}"
  GOSUB FIXCURSOR
  SCREEN 1
  COLOR 1,0
  CLS
  PRINT " TESTING FILE SYSTEM"
  GOSUB TestFileSystem
  CLS:PRINT:PRINT
  IF IsHostFS THEN PRINT "{WHT} HOST {GRN}File System Detected":GOTO STARTMOVIE
  PRINT "{WHT} SD-Card {GRN}file System Detected"

STARTMOVIE:
  #INCLUDE "MOVIE.DEF"
  GOSUB BASENAME.TO.UPPER
  PRINT
  FRAMEFILE$=BASENAME$+".SPV"
  AUDIOTRACK$=BASENAME$+".SVA"
  F$=FRAMEFILE$:GOSUB FILEEXISTS
  IF NOT FE% THEN PRINT FRAMEFILE$;" NOT FOUND !":SLEEP 180:PRINT:GOTO STARTMOVIE
  F$=AUDIOTRACK$:GOSUB FILEEXISTS
  IF NOT FE% THEN PRINT AUDIOTRACK$;" NOT FOUND !":SLEEP 180:PRINT:GOTO STARTMOVIE

  IF IsHostFS THEN SKIPFAST
     DOS "U0>B3"
     FASTMODE = -1
SKIPFAST:

OPEN 6,8,6,AUDIOTRACK$+",S,R"
OPEN 4,8,4,FRAMEFILE$+",S,R"

  GOSUB GET.VIDEO.HEADER
  GOSUB SET.VIDEO.ATTRIBUTES

  GOSUB LOADMLPLAYER

  GOSUB SET.AUDIOCODE
  GOSUB CALCULATE.SPRITES
  GOSUB SET.SPRITECODE

  GOSUB PAL2BLACK
  GOSUB SetUpSprites

  SCREEN 0
  COLOR 1,0:CLS


  SCALER=38
  IF FRAMEWIDTH=160 THEN SCALER = 32
  POKE HSCALE, SCALER
  POKE VSCALE, SCALER

ZEROALL:
## Initially zero out the Sprite RAM
  BANK 10
  SYS $A003


PLAY.BadApple:
   POKE R0L, VERA.RATE
   POKE R0H, VERA.CFG
   POKE R15L, 1
   BANK 10
   SYS $A000
   SYS CLRCHN
   CLOSE 4
   CLOSE 6
   SLEEP 90

CLEANUPANDEND:
   FOR I = 1 TO (NUMSPRITES*2):SPRITE I,0:NEXT
   SCREEN 0
   COLOR 1,6:CLS
   GOSUB SETDEFPAL
REALLYDONE:
   SCREEN 0
   COLOR 1,6:CLS
   PRINT
   BANNER
   END


BASENAME.TO.UPPER:
  L = LEN(BASENAME$)
  TMP$=""
  FOR I = 1 TO L
      C$=MID$(BASENAME$,I,1)
      C = ASC(C$)
      IF C > 96 AND C< 123 THEN C=C-32
      IF C > 192 AND C<219 THEN C=C-128
      TMP$=TMP$+CHR$(C)
  NEXT
  BASENAME$=TMP$
RETURN

GET.VIDEO.HEADER:
  PRINT " {LIGHT GREEN}READING VIDEO HEADER"
  VHEADER$ = RPT$(32,32)
  A = POINTER(VHEADER$)+1
  POKE X.REG, 4
  SYS CHKIN
  POKE A.REG, 32
  POKE X.REG, PEEK(A)
  POKE Y.REG, PEEK(A+1)
  POKE C.REG, 0
  SYS MACPTR
  SYS CLRCHN
RETURN

SET.VIDEO.ATTRIBUTES:
  ID$ = LEFT$(VHEADER$,4)
  IF ID$ <> "SPRV" THEN PRINT "BAD VIDEO FILE ID {RED}";ID$:PRINT:STOP
  VTYPE = ASC(MID$(VHEADER$,5,1))
  IF VTYPE<>1 THEN PRINT "BAD VIDEO FILE TYPE {RED}";VTYPE:PRINT:STOP
  BPP = ASC(MID$(VHEADER$,6,1))
  IF BPP<>8 AND BPP<> 4 THEN PRINT "UNSUPPORTED VIDEO FILE BPP {RED}";BPP:PRINT:STOP
  FPS = ASC(MID$(VHEADER$,7,1))
  SPRWIDTH = ASC(MID$(VHEADER$,8,1))
  SPRHEIGHT = ASC(MID$(VHEADER$,9,1))
  FRAMEWIDTH = ASC(MID$(VHEADER$,10,1)) + (256 * ASC(MID$(VHEADER$,11,1)))
  FRAMEHEIGHT = ASC(MID$(VHEADER$,12,1)) + (256 * ASC(MID$(VHEADER$,13,1)))
  NUMFRAMES = ASC(MID$(VHEADER$,14,1)) + (256 * ASC(MID$(VHEADER$,15,1))) + (65536 * ASC(MID$(VHEADER$,16,1)))
  NUMSPRITES = (FRAMEWIDTH/SPRWIDTH) * (FRAMEHEIGHT/SPRHEIGHT)
  PALSIZE = 512
  SPRITE.VBANK = 0
  SPRITE.ORIG.ADDR = 0
  IF BPP = 4 THEN PALSIZE = 0:SPRITE.VBANK = 1:SPRITE.ORIG.ADDR = $3000
RETURN

SET.AUDIOCODE:
  CHANNEL = 6
  GOSUB GETFILESIZE
  ASIZE = FILESIZE / NUMFRAMES
  ASIZE = FN ROUND(ASIZE)
  DRATE = ASIZE*FPS
  VERA.RATE = FN ROUND((DRATE/VERABASERATE) * VERARATEDIVISOR ) - 1
  APLOOPS = 1
  IF ASIZE < 2048 THEN APLOOPS = 2
  M255 = INT(ASIZE/255)
  AREMAINDER = ASIZE - (255*M255)
  IF AREMAINDER = 0 THEN AREMAINDER = 255:M255 = M255-1
  BANK 10
  POKE R0L, APLOOPS
  POKE R0H, M255
  POKE R1L, AREMAINDER
  POKE R1H, M255
  POKE R2L, AREMAINDER
  BANK 10
  SYS $A006
RETURN

CALCULATE.SPRITES:
  SPR.DATA.SIZE = SPRHEIGHT * SPRWIDTH
  IF BPP = 4 THEN SPR.DATA.SIZE = SPR.DATA.SIZE/2
  SPR.FRAME.SIZE = SPR.DATA.SIZE * NUMSPRITES
  SPR.ATTR.ENDADDR = $FC06 + (NUMSPRITES*8*2)
  SPR.BLOCK2.DATAADDR = SPRITE.ORIG.ADDR+(SPR.FRAME.SIZE) + PALSIZE
RETURN

SET.SPRITECODE:
  SBuff255 = INT(SPR.FRAME.SIZE/255)
  SBuffRem = SPR.FRAME.SIZE - (255*SBuff255)
  IF SBuffRem = 0 THEN SBuffRem = 255:SBuff255=SBuff255 - 1
  POKE R3L, SBuff255
  POKE R3H, SBuffRem
  POKE R4L, NUMSPRITES
  POKE R5L, FN Lo.Byte(SPR.ATTR.ENDADDR)
  POKE R5H, FN Hi.Byte(SPR.ATTR.ENDADDR)
  POKE R6H, FN Hi.Byte(SPR.BLOCK2.DATAADDR)
  BANK 10
  IF BPP = 4 THEN SYS $A00C:RETURN
  SYS $A009
RETURN

SetUpSprites:
   SPR.DEPTH = 1
   SPR.PAL1 = 0
   SPR.PAL2 = 0
   IF BPP = 4 THEN SPR.DEPTH = 0:SPR.PAL1 = 14:SPR.PAL2=15
   Y1 = 4
   IF FRAMEHEIGHT = 128 THEN Y1=7
   S.WIDTH = -1
   IF SPRWIDTH = 64 THEN S.WIDTH = 3
   IF SPRWIDTH = 32 THEN S.WIDTH = 2
   IF SPRWIDTH = 16 THEN S.WIDTH = 1
   IF SPRWIDTH = 8 THEN S.WIDTH = 0
   IF S.WIDTH = -1 THEN PRINT "SPRITE ERROR: ";SPRWIDTH;" WIDTH VAR":STOP
   S.HEIGHT = -1
   IF SPRHEIGHT = 64 THEN S.HEIGHT = 3
   IF SPRHEIGHT = 32 THEN S.HEIGHT = 2
   IF SPRHEIGHT = 16 THEN S.HEIGHT = 1
   IF SPRHEIGHT = 8 THEN S.HEIGHT = 0
   IF S.HEIGHT = -1 THEN PRINT "SPRITE ERROR: ";SPRHEIGHT;" HEIGHT VAR":STOP
   XORG = 0
   X1 = XORG:VADDR=SPRITE.ORIG.ADDR
   VADD.ON = (SPR.DATA.SIZE*NUMSPRITES) + PALSIZE
   FOR SPR = 1 TO NUMSPRITES
     SPRMEM SPR,SPRITE.VBANK,VADDR
     SPRMEM SPR+NUMSPRITES,SPRITE.VBANK,VADDR+VADD.ON
     VADDR = VADDR + SPR.DATA.SIZE
     SPRITE SPR, 3, SPR.PAL1, 0, S.WIDTH, S.HEIGHT,SPR.DEPTH
     SPRITE SPR+NUMSPRITES, 0, SPR.PAL2, 0, S.WIDTH, S.HEIGHT,SPR.DEPTH
     MOVSPR SPR, X1,Y1
     MOVSPR SPR+NUMSPRITES, X1, Y1
     X1=X1+SPRWIDTH:IF X1>=XORG + FRAMEWIDTH THEN X1=XORG:Y1=Y1 + SPRHEIGHT
   NEXT
RETURN

WAITFORKEY:
  SYS CLRCHN
WAIT1:
  GET X$:IF X$<>"" THEN WAIT1
GETKEY:
  GET X$
  IF X$="" THEN GETKEY
RETURN

TestFileSystem:
 F$="TESTFILE":GOSUB FILEEXISTS
 IF FE% THEN StartTest
 OPEN 2,8,2,"@:TESTFILE,S,W"
 FOR I = 1 TO 100
     PRINT# 2, "ABCDEFGHIJKLMN"
 NEXT I
 CLOSE 2
StartTest:
 OPEN 2,8,2,"TESTFILE,S,R"
 POKE X.REG,2
 SYS CHKIN
 BANK 63
 POKE X.REG,$00
 POKE Y.REG,$A0
 POKE C.REG, 0
 POKE A.REG, 0
 SYS MACPTR
 IsHostFS = (PEEK(Y.REG) = 1)
 SYS CLRCHN
 CLOSE 2
 RETURN

GETFILESIZE:
 OPEN 15,8,15, "T" + CHR$(CHANNEL)
 INPUT#15,A,A$,T,S
 CLOSE 15
 IF A>=20 THEN FILESIZE = 0:RETURN
 FILESIZE=VAL("$"+MID$(A$,9))
RETURN

#INCLUDE "STANDARD.BI"

SETDEFPAL:
      F$="DPAL.BIN":GOSUB FILEEXISTS
      IF FE% THEN BVLOAD F$,8,1,$FA00:RETURN
      POKE $9F20, 0
      POKE $9F21, $FA
      POKE $9F22, %00010001
      RESTORE PALDATA
REM LOOP THROUGH THE PALLETTE ADDRESS SPACE
REM AND POKE THE VERA DEFAULT PALLETTE
      FOR PE = 1 TO 256:READ R:READ GB:POKE VERA.DATA0,GB:POKE VERA.DATA0,R:NEXT
      RETURN

REM DEFAULT VERA PALLETTE AS DATA. FROM 0 TO 255 (2 BYTES EACH ENTRY)RGB
PALDATA:
      DATA $00,$00,$0F,$FF,$08,$00,$0A,$FE,$0C,$4C,$00,$C5,$00,$0A,$0E,$E7,$0D
      DATA $85,$06,$40,$0F,$77,$03,$33,$07,$77,$0A,$F6,$00,$8F,$0B,$BB,$00,$00
      DATA $01,$11,$02,$22,$03,$33,$04,$44,$05,$55,$06,$66,$07,$77,$08,$88,$09
      DATA $99,$0A,$AA,$0B,$BB,$0C,$CC,$0D,$DD,$0E,$EE,$0F,$FF,$02,$11,$04,$33
      DATA $06,$44,$08,$66,$0A,$88,$0C,$99,$0F,$BB,$02,$11,$04,$22,$06,$33,$08
      DATA $44,$0A,$55,$0C,$66,$0F,$77,$02,$00,$04,$11,$06,$11,$08,$22,$0A,$22
      DATA $0C,$33,$0F,$33,$02,$00,$04,$00,$06,$00,$08,$00,$0A,$00,$0C,$00,$0F
      DATA $00,$02,$21,$04,$43,$06,$64,$08,$86,$0A,$A8,$0C,$C9,$0F,$EB,$02,$11
      DATA $04,$32,$06,$53,$08,$74,$0A,$95,$0C,$B6,$0F,$D7,$02,$10,$04,$31,$06
      DATA $51,$08,$62,$0A,$82,$0C,$A3,$0F,$C3,$02,$10,$04,$30,$06,$40,$08,$60
      DATA $0A,$80,$0C,$90,$0F,$B0,$01,$21,$03,$43,$05,$64,$07,$86,$09,$A8,$0B
      DATA $C9,$0D,$FB,$01,$21,$03,$42,$04,$63,$06,$84,$08,$A5,$09,$C6,$0B,$F7
      DATA $01,$20,$02,$41,$04,$61,$05,$82,$06,$A2,$08,$C3,$09,$F3,$01,$20,$02
      DATA $40,$03,$60,$04,$80,$05,$A0,$06,$C0,$07,$F0,$01,$21,$03,$43,$04,$65
      DATA $06,$86,$08,$A8,$09,$CA,$0B,$FC,$01,$21,$02,$42,$03,$64,$04,$85,$05
      DATA $A6,$06,$C8,$07,$F9,$00,$20,$01,$41,$01,$62,$02,$83,$02,$A4,$03,$C5
      DATA $03,$F6,$00,$20,$00,$41,$00,$61,$00,$82,$00,$A2,$00,$C3,$00,$F3,$01
      DATA $22,$03,$44,$04,$66,$06,$88,$08,$AA,$09,$CC,$0B,$FF,$01,$22,$02,$44
      DATA $03,$66,$04,$88,$05,$AA,$06,$CC,$07,$FF,$00,$22,$01,$44,$01,$66,$02
      DATA $88,$02,$AA,$03,$CC,$03,$FF,$00,$22,$00,$44,$00,$66,$00,$88,$00,$AA
      DATA $00,$CC,$00,$FF,$01,$12,$03,$34,$04,$56,$06,$68,$08,$8A,$09,$AC,$0B
      DATA $CF,$01,$12,$02,$24,$03,$46,$04,$58,$05,$6A,$06,$8C,$07,$9F,$00,$02
      DATA $01,$14,$01,$26,$02,$38,$02,$4A,$03,$5C,$03,$6F,$00,$02,$00,$14,$00
      DATA $16,$00,$28,$00,$2A,$00,$3C,$00,$3F,$01,$12,$03,$34,$05,$46,$07,$68
      DATA $09,$8A,$0B,$9C,$0D,$BF,$01,$12,$03,$24,$04,$36,$06,$48,$08,$5A,$09
      DATA $6C,$0B,$7F,$01,$02,$02,$14,$04,$16,$05,$28,$06,$2A,$08,$3C,$09,$3F
      DATA $01,$02,$02,$04,$03,$06,$04,$08,$05,$0A,$06,$0C,$07,$0F,$02,$12,$04
      DATA $34,$06,$46,$08,$68,$0A,$8A,$0C,$9C,$0F,$BE,$02,$11,$04,$23,$06,$35
      DATA $08,$47,$0A,$59,$0C,$6B,$0F,$7D,$02,$01,$04,$13,$06,$15,$08,$26,$0A
      DATA $28,$0C,$3A,$0F,$3C,$02,$01,$04,$03,$06,$04,$08,$06,$0A,$08,$0C,$09
      DATA $0F,$0B

LOADMLPLAYER:
 F$="PLAYVIDEO.V2.BIN":GOSUB FILEEXISTS
 IF FE% THEN BLOAD "PLAYVIDEO.V2.BIN",8,10,$A000:RETURN
 ADDR = $A000
 PRINT
 PRINT "{YEL} PLAYVIDEO.V2.BIN {LIGHT GREEN}Not Found !":PRINT
 PRINT "{WHT} POKING the Code:{YEL}";
 RESTORE VIDEOPLAYERCODE
 BANK 10
 FOR AZ = $A000 TO $A39F
     READ C
     POKE AZ, C
     PRINT ".";
 NEXT
 PRINT:PRINT
 SLEEP 90
 CLS
RETURN

VIDEOPLAYERCODE:
DATA 76,15,160,76,2,163,76,32,163,76,60,163,76,110,163,165,2,133,50,165,3,9,15,133,51,165,1,72,100,1,100,112,100,113,156,60,159,169,128,141,59,159,165,51,141,59,159,169,2,133,102,162,6,32
DATA 198,255,169,6,133,103,162,61,160,159,169,255,56,32,68,255,198,103,208,242,162,61,160,159,169,114,56,32,68,255,198,102,208,224,169,6,133,103,32,204,255,100,32,165,50,141,60,159,32,30
DATA 161,165,112,201,0,208,81,162,6,32,198,255,173,39,159,41,8,240,249,162,61,160,159,169,255,56,32,68,255,162,61,160,159,169,255,56,32,68,255,165,112,201,0,208,43,165,50,141,60,159,169
DATA 4,133,103,162,61,160,159,169,255,56,32,68,255,198,103,208,242,162,61,160,159,169,114,56,32,68,255,32,183,255,208,21,32,189,254,208,22,165,113,201,0,208,55,32,30,161,32,183,255,208,40
DATA 128,153,169,255,133,112,128,234,156,60,159,32,204,255,32,228,255,201,27,240,11,201,32,240,38,165,50,141,60,159,128,210,169,255,133,113,133,112,128,202,169,255,133,113,76,105,160,165
DATA 112,201,0,208,3,76,105,160,32,204,255,104,133,1,96,32,228,255,201,27,240,203,201,32,240,2,128,243,169,0,128,193,162,4,32,198,255,169,70,133,2,165,32,240,19,162,54,160,254,169,73,32
DATA 152,161,100,32,156,32,159,156,33,159,128,21,162,14,160,252,169,65,32,152,161,169,1,133,32,156,32,159,169,72,141,33,159,169,16,141,34,159,162,35,160,159,169,255,56,32,68,255,198,2,208
DATA 242,162,35,160,159,169,70,56,32,68,255,173,32,159,133,52,173,33,159,133,53,162,35,160,159,169,255,56,32,68,255,162,35,160,159,169,255,56,32,68,255,162,35,160,159,169,2,56,76,68,255
DATA 142,32,159,140,33,159,141,34,159,169,1,141,37,159,165,52,141,32,159,165,53,141,33,159,169,16,141,34,159,156,37,159,162,35,160,35,169,12,203,141,35,159,202,208,250,156,35,159,136,208
DATA 250,156,32,159,169,250,141,33,159,169,17,141,34,159,162,32,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141
DATA 35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159,173,36,159,141,35,159
DATA 173,36,159,141,35,159,173,36,159,141,35,159,202,208,157,96,162,4,32,198,255,169,35,133,2,165,32,240,25,162,54,160,254,169,73,32,179,162,162,192,134,38,100,32,156,32,159,169,48,141,33
DATA 159,128,25,162,14,160,252,169,65,32,179,162,162,224,134,38,169,1,133,32,156,32,159,169,83,141,33,159,169,17,141,34,159,162,35,160,159,169,255,56,32,68,255,198,2,208,242,162,35,160,159
DATA 169,35,56,32,68,255,165,38,141,32,159,169,251,141,33,159,169,17,141,34,159,162,35,160,159,169,32,56,76,68,255,203,142,32,159,140,33,159,141,34,159,162,35,160,35,169,12,141,35,159,202
DATA 208,250,156,35,159,136,208,250,165,38,141,32,159,169,251,141,33,159,169,17,141,34,159,173,35,159,141,0,163,173,35,159,141,1,163,156,32,159,169,250,141,33,159,173,0,163,141,35,159,173
DATA 1,163,141,35,159,96,0,0,0,156,32,159,156,33,159,169,16,141,34,159,169,0,160,2,162,150,156,35,159,26,208,250,202,208,247,136,208,242,96,165,2,141,48,160,165,3,141,57,160,165,4,141,79
DATA 160,165,5,58,58,141,155,160,165,6,141,177,160,96,165,8,141,36,161,165,9,141,107,161,165,10,141,185,161,141,187,161,165,12,141,44,161,165,13,141,46,161,165,15,141,79,161,169,30,162,161
DATA 141,103,160,141,199,160,142,104,160,142,200,160,96,165,8,141,68,162,165,9,141,149,162,165,10,141,190,162,141,192,162,165,12,141,76,162,165,13,141,78,162,165,15,141,121,162,169,62,162
DATA 162,141,103,160,141,199,160,142,104,160,142,200,160,96

REM 928  BYTES CONVERTED







